package com.hnj.serialportdemo;


import com.hnj.dp_nserialportlist.Serialport_Factory;
import com.hnj.serialportdemo.util.SharedPreferencesUtil;
import com.hnj.serialportdemo.util.Toast_Util;
import com.hnj.serialportdemo.view.PopMenu;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

public class MainActivity extends AppCompatActivity {

    private static String TAG = "MainActivity";
    private RelativeLayout input_prl,drivername_prl;
    public PopMenu versions,drivername_pm;
    private TextView baud_rate_et,drivername_tv;
    private Button openserialport_bt,ptprint_bt,paper_bt;
    public static Serialport_Factory sf;
    private TextView serialconnt_tv,paper_tv;
    private Handler mhandler;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.fragment_main);
        mhandler=new MHandler();
        sf=Serialport_Factory.getSerialport_Factory(this,mhandler);
        SharedPreferencesUtil.initPreferences(this);
        paper_tv=(TextView)findViewById(R.id.paper_tv);
        serialconnt_tv=(TextView)findViewById(R.id.serialconnt_tv);
        openserialport_bt=(Button)findViewById(R.id.openserialport_bt);
        ptprint_bt=(Button)findViewById(R.id.ptprint_bt);
        paper_bt=(Button)findViewById(R.id.paper_bt);
        baud_rate_et=(TextView)findViewById(R.id.baud_rate_et);
        drivername_tv=(TextView)findViewById(R.id.drivername_tv);
        input_prl=(RelativeLayout)findViewById(R.id.input_prl);
        drivername_prl=(RelativeLayout)findViewById(R.id.drivername_prl);
        versions = new PopMenu();
        drivername_pm = new PopMenu();
        getbaud_rate();
        versions.setOnItemClickListener(new PopMenu.OnItemClickListener() {
            @Override
            public void onItemClick(int index) {
                String str=versions.getItem(index);
                baud_rate_et.setText(str);
            }
        });

        drivername_pm.setOnItemClickListener(new PopMenu.OnItemClickListener() {
            @Override
            public void onItemClick(int index) {
                String str=drivername_pm.getItem(index);
                drivername_tv.setText(str);
            }
        });
        input_prl.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                versions.showAsDropDown(v,getApplicationContext(),v.getWidth());
            }
        });
        drivername_prl.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                drivername_pm.showAsDropDown(v,getApplicationContext(),v.getWidth());
            }
        });
        openserialport_bt.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View arg0) {
                String com_name=drivername_tv.getText().toString().trim();
                String baud_rate=baud_rate_et.getText().toString().trim();
                if(com_name.equals("")||baud_rate.length()<=0)
                {
                    Toast_Util.ToastString(getApplicationContext(), R.string.please_enter_a_serial_port_name);
                }else {

                    boolean isopen=false;
                    if(!baud_rate.equals("")&&!com_name.equals(""))
                    {
                        isopen=MainActivity.sf.OpenPort(com_name, baud_rate);
                    }else {
                        isopen=MainActivity.sf.OpenPort("ttyS0", "115200");//默认连接
                    }
                    if(isopen)
                    {
                        serialconnt_tv.setText("串口已打开    ");
                        SharedPreferencesUtil.savecom_name(com_name);
                        SharedPreferencesUtil.savebaud_rate(baud_rate);

                    }else {

                        serialconnt_tv.setText("串口打开失败    ");
                    }
                }
            }
        });

        ptprint_bt.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                if(sf.isConnection())
                {
                    Intent intent=new Intent(MainActivity.this,NormalPrintActivity.class);
                    startActivity(intent);
                }else {
                    Toast_Util.ToastString(getApplicationContext(), R.string.unconnected); //打印机未连接
                }
            }
        });
        SetActivity.setonConnectState(new SetActivity.onConnectState() {
            @Override
            public void onResult(boolean isopen,String comname) {
                if(isopen)
                {
                    mcomname=comname;
                }else {
                    serialconnt_tv.setText("打印机未连接    "+comname);
                }
            }
        });
        paper_bt.setOnClickListener(new  OnClickListener() {
            @Override
            public void onClick(View v) {
                // TODO Auto-generated method stub
                if(sf.isConnection())
                {
                    boolean t=sf.Check_Paper();
                    if(t)
                    {
                        Toast_Util.ToastString(getApplicationContext(), R.string.printer_have_paper);
                    }else {
                        Toast_Util.ToastString(getApplicationContext(), R.string.printer_does_not_have_paper);
                    }
                }else {
                    Toast_Util.ToastString(getApplicationContext(), R.string.unconnected); //打印机未连接
                }
            }
        });
        //onCreate页面启动后1秒自动打开串口
        mhandler.sendEmptyMessageDelayed(OPENPORT, 1000);

    }
    private String mcomname="";
    public static boolean ispage=false;//纸张状态
    public final int OPENPORT=0x336;//打开串口
    int ct=0;
    @SuppressLint("HandlerLeak")
    class MHandler extends Handler {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            switch (msg.what) {
                case OPENPORT: {
                    String com_name=SharedPreferencesUtil.getcom_name();
                    String baud_rate=SharedPreferencesUtil.getbaud_rate();
                    Log.e(TAG, "=====com_name===="+com_name);
                    Log.e(TAG, "=====baud_rate===="+baud_rate);
                    if(!com_name.equals(""))
                    {
                        boolean isopen=sf.OpenPort(com_name, baud_rate);
                        if(isopen)
                        {
                            mcomname=com_name;
                            serialconnt_tv.setText("串口已打开    ");
                        }else {
                            serialconnt_tv.setText("串口未打开    ");
                        }
                    }else{

                    }
                    break;
                }

                case Serialport_Factory.PAPER_STATE:{//检查缺纸状态
                    boolean p=msg.getData().getBoolean("PAPER_STATE");
                    if(p)
                    {
                        ispage=true;
                        paper_tv.setText("打印机有纸");
//								Toast_Util.ToastString(getApplicationContext(), "打印机有纸");
                    }else {
                        ct++;
                        ispage=false;
                        paper_tv.setText("打印机缺纸=="+ct);
//                        Toast_Util.ToastString(getApplicationContext(), "打印机缺纸==");
                    }
                    break;
                }
                case Serialport_Factory.PRINTSTATE:{//打印状态
                    boolean printstate=msg.getData().getBoolean("printstate");
                    if(printstate)
                    {
                        Toast_Util.ToastString(getApplicationContext(), "打印完成");//打印完成
                    }else
                    {
                        Toast_Util.ToastString(getApplicationContext(), "打印失败");//打印失败
                    }

                    break;
                }
            }
        }
    }

    //初始化波特率和串口名称
    private void getbaud_rate()
    {
        String baudrate=SharedPreferencesUtil.getbaud_rate();
        String comname=SharedPreferencesUtil.getcom_name();
        if(baudrate!=null)
        {
            if(baudrate.length()==0){
                baud_rate_et.setText("115200");
            }else {
                baud_rate_et.setText(baudrate);
            }
        }
        if(comname!=null)
        {
            if(comname.length()==0){
                drivername_tv.setText("ttyS1");
            }else {
                drivername_tv.setText(comname);
            }
        }
        versions.clearItems();
        versions.addItem("1200");
        versions.addItem("2400");
        versions.addItem("4800");
        versions.addItem("9600");
        versions.addItem("14400");
        versions.addItem("19200");
        versions.addItem("38400");
        versions.addItem("57600");
        versions.addItem("115200");
        versions.addItem("230400");
        versions.addItem("256000");
        versions.addItem("500000");
        versions.addItem("750000");
        versions.addItem("1125000");
        String dlist[]=MainActivity.sf.getAllDevices();
        drivername_pm.clearItems();
        for(int i=0;i<dlist.length;i++)
        {
            drivername_pm.addItem(dlist[i]);
        }
    }
}