package com.hnj.serialportdemo;

import com.hnj.serialportdemo.util.SharedPreferencesUtil;
import com.hnj.serialportdemo.util.Toast_Util;
import com.hnj.serialportdemo.view.PopMenu;
import com.hnj.serialportdemo.view.PopMenu.OnItemClickListener;


import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class SetActivity extends Activity {

	private RelativeLayout input_prl,drivername_prl;
	public PopMenu versions,drivername_pm;
	private TextView baud_rate_et,drivername_tv;
	private Button save_set_bt;
	private ImageView back_iv;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().setSoftInputMode( WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);
		setContentView(R.layout.activity_set);
		baud_rate_et=(TextView)findViewById(R.id.baud_rate_et);
		drivername_tv=(TextView)findViewById(R.id.drivername_tv);
		input_prl=(RelativeLayout)findViewById(R.id.input_prl);
		drivername_prl=(RelativeLayout)findViewById(R.id.drivername_prl);
		save_set_bt=(Button)findViewById(R.id.save_set_bt);
		back_iv=(ImageView)findViewById(R.id.back_iv);
		versions = new PopMenu();
		drivername_pm = new PopMenu();
		getbaud_rate();
		versions.setOnItemClickListener(new OnItemClickListener() {			
			@Override
			public void onItemClick(int index) {
				String str=versions.getItem(index);
				baud_rate_et.setText(str);	
			}
		});
		
		drivername_pm.setOnItemClickListener(new OnItemClickListener() {			
			@Override
			public void onItemClick(int index) {
				String str=drivername_pm.getItem(index);
				drivername_tv.setText(str);	
			}
		});
		input_prl.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View v) {				
				versions.showAsDropDown(v,getApplicationContext(),v.getWidth());				
			}
		});
		drivername_prl.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View v) {				
				drivername_pm.showAsDropDown(v,getApplicationContext(),v.getWidth());				
			}
		});
		save_set_bt.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View arg0) {
				String com_name=drivername_tv.getText().toString().trim();
				String baud_rate=baud_rate_et.getText().toString().trim();
				if(com_name.equals("")||baud_rate.length()<=0)
				{
					Toast_Util.ToastString(getApplicationContext(), R.string.please_enter_a_serial_port_name);
				}else {
					
					boolean isopen=false;
					if(!baud_rate.equals("")&&!com_name.equals(""))
					{
						isopen=MainActivity.sf.OpenPort(com_name, baud_rate);
					}else {
						isopen=MainActivity.sf.OpenPort("ttyS0", "115200");  
					}	
					if(isopen)
					{
//						Toast_Util.ToastString(getApplicationContext(), R.string.connected);
						SharedPreferencesUtil.savecom_name(com_name);
						SharedPreferencesUtil.savebaud_rate(baud_rate);
						if(mcs!=null)
						{
							mcs.onResult(true,com_name);
						}
						finish();
					}else {
						if(mcs!=null)
						{
							mcs.onResult(false,com_name);
						}
						Toast_Util.ToastString(getApplicationContext(), R.string.unconnected);
					}
				}				
			}
		});
		back_iv.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				finish();
			}
		});
	}
	
	
	private void getbaud_rate()
	{
		String baudrate=SharedPreferencesUtil.getbaud_rate();
		String comname=SharedPreferencesUtil.getcom_name();
		if(baudrate!=null)
		{
			if(baudrate.length()==0){
				baud_rate_et.setText("115200");
			}else {
				baud_rate_et.setText(baudrate);
			}
		}
		if(comname!=null)
		{
			if(comname.length()==0){
				drivername_tv.setText("ttyS1");
			}else {
				drivername_tv.setText(comname);
			}			
		}
		versions.clearItems();		
		versions.addItem("1200");
		versions.addItem("2400");
		versions.addItem("4800");
		versions.addItem("9600");
		versions.addItem("14400");
		versions.addItem("19200");
		versions.addItem("38400");
		versions.addItem("57600");
		versions.addItem("115200");
		versions.addItem("230400");
		versions.addItem("256000");
		versions.addItem("500000");
		versions.addItem("750000");
		versions.addItem("1125000");
		String dlist[]=MainActivity.sf.getAllDevices();
		drivername_pm.clearItems();
		for(int i=0;i<dlist.length;i++)
		{
			drivername_pm.addItem(dlist[i]);
		}
	}
	
	
	private static onConnectState mcs = null;	
 	public static void setonConnectState(onConnectState aResult){
 		mcs = aResult;
 	}
 	
 	public static interface onConnectState {
 	    void onResult(boolean cs,String name);
 	}
}
